// DCGSexpressionObject.h
#ifndef _DCGSEXPRESSIONOBJECT_H_
#define _DCGSEXPRESSIONOBJECT_H_
#include "DCGSexpr.h"
typedef void *FN(int,void **);
typedef FN *PFN;

class expression {
	virtual int evalprintInt(FILE *f, char *fmt,constvar res);
	virtual int printpar(FILE *f,char *fmt, int priority);
	int updateUsage(int delta);
	void clean();

public:
	~expression();
	expression *initDebugLast(int line, char *function, char *file);
	// variable only
	bool rename1(char *newname,long line, char *function, char *file);
	constvar *setVal(unsigned long long v);
	// common functions
	virtual int print();
	virtual int printExpr();
	constvar evalprint();
	constvar evalprint(FILE *f,char *fmt);
	constvar evalprintDbg(FILE *f,char *fmt);
	constvar evalprintDbg();
	constvar typedEvalprint(FILE *f,char *fmt,Const tp);
	virtual int print(FILE *f,char *fmt=NULL);
	virtual int printExpr(FILE *f,char *fmt="%s");
	virtual char *getName();
	virtual constvar &eval();   	// evaluate expression
	virtual constvar &evalInt();
	virtual constvar &typedEval(Const typeV);
	classes getType();
	int getTypeInt();
};
#endif
